package com.xydl.cac.comparator;


import com.xydl.cac.exception.BusinessException;

import java.util.Date;
import java.util.LinkedHashMap;

public class IntCompare extends Comparator {

    @Override
    public boolean compare(Object source, String threshold, Date lastDTime) {
        if (source != null) {
            int s1;
            if (source instanceof Integer) {
                s1 = (int) source;
            } else {
                s1 = Integer.valueOf(source.toString());
            }

            if ("BTW".equalsIgnoreCase(operator)) {
                String[] strs = threshold.split(",");
                int t1 = Integer.parseInt(strs[0]);
                int t3 = Integer.parseInt(strs[1]);
                if (t1 <= s1 && s1 <= t3) {
                    return true;
                }
            } else if ("NTW".equalsIgnoreCase(operator)) {
                String[] strs = threshold.split(",");
                float t1 = Float.parseFloat(strs[0]);
                float t3 = Float.parseFloat(strs[1]);
                if (t1 > s1 || s1 > t3) {
                    return true;
                }
            } else {
                int t2 = Integer.parseInt(threshold);

                if ("EQU".equalsIgnoreCase(operator) && s1 == t2) {
                    return true;
                } else if ("NEQ".equalsIgnoreCase(operator) && s1 != t2) {
                    return true;
                } else if ("LSS".equalsIgnoreCase(operator) && s1 < t2) {
                    return true;
                } else if ("LEQ".equalsIgnoreCase(operator) && s1 <= t2) {
                    return true;
                } else if ("GTR".equalsIgnoreCase(operator) && s1 > t2) {
                    return true;
                } else if ("GEQ".equalsIgnoreCase(operator) && s1 >= t2) {
                    return true;
                }
            }
        }
        return false;
    }

    @Override
    public LinkedHashMap<String, String> supportedOperator() {
        LinkedHashMap<String, String> map = new LinkedHashMap<String, String>();
        map.put("GTR", "大于");
        map.put("GEQ", "大等于");
        map.put("LSS", "小于");
        map.put("LEQ", "小等于");
        map.put("BTW", "介于A-B之间");
        map.put("NTW", "在A-B之外");
        return map;
    }

    @Override
    public void valid(String operator, String threshold) throws Exception {
        if ("BTW".equalsIgnoreCase(operator)) {
            if (!threshold.contains(",")) {
                throw new BusinessException("阈值不正确");
            }
        } else if ("NTW".equalsIgnoreCase(operator)) {
            if (!threshold.contains(",")) {
                throw new BusinessException("阈值不正确");
            }
        }
    }

}
