package com.xydl.cac.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;

@JsonInclude(JsonInclude.Include.NON_NULL)
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "i2sync_config")
@ApiModel("i2导出类型配置")
public class I2syncConfig {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Integer id;

    @NotNull(message = "modevtypeId不能为空")
    @Column(name = "modevtype_id")
    private Integer modevtypeId;

    @Column(name = "create_time")
    private Date createTime;

    @ApiModelProperty("类型名称")
    @Transient
    private String typeName;
    @ApiModelProperty("对应的表名")
    @Transient
    private String tableName;
    @ApiModelProperty("类型编码")
    @Transient
    private String typeCode;

}