package com.xydl.cac.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;

@JsonInclude(JsonInclude.Include.NON_NULL)
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "icd_transform")
@ApiModel("ICD")
public class IcdTransform {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Integer id;

    @ApiModelProperty(name = "rpt_from")
    @Column(name = "rpt_from")
    private String rptFrom;

    @ApiModelProperty(name = "rpt_to")
    @Column(name = "rpt_to")
    private String rptTo;

    @Transient
    private boolean fromActive;
    @Transient
    private boolean toActive;
}
