package com.xydl.cac.entity;

import com.xydl.cac.model.spectrogram.SpectrogramModel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.util.Date;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "ied_dl_record")
@ApiModel("61850装置文件下载记录表")
public class IedDlRecord {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Integer id;

    @ApiModelProperty("configId")
    @Column(name = "config_id")
    private Integer configId;

    @ApiModelProperty("源路径")
    @Column(name = "remote_path")
    private String remotePath;

    @ApiModelProperty("本地路径")
    @Column(name = "path")
    private String path;

    @ApiModelProperty("文件名")
    @Column(name = "filename")
    private String filename;

    @ApiModelProperty("采集时间")
    @Column(name = "d_time")
    private Date dTime;

    @ApiModelProperty("创建时间")
    @Column(name = "create_time")
    private Date createTime;

    @ApiModelProperty("devId")
    @Column(name = "dev_id")
    private Integer devId;

    @ApiModelProperty("typeId")
    @Column(name = "type_id")
    private Integer typeId;

    @ApiModelProperty("解析后数据")
    @Column(name = "data")
    private String data;

    @Transient
    IedDlConfig config;
    @Transient
    SpectrogramModel model;

}