package com.xydl.cac.entity;

import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;

@JsonInclude(JsonInclude.Include.NON_NULL)
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "n_103_point")
@ApiModel("装置点表")
public class N103Point {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Integer id;

    @ApiModelProperty("NPoint表的id")
    @Column(name = "npoint_id")
    private Integer npointId;

    @ApiModelProperty("N103Sensor表的id")
    @Column(name = "sensor_103_id")
    private Integer sensor103Id;

    @ApiModelProperty("信息体地址")
    @Column(name = "sadr")
    private String sadr;

    @ApiModelProperty("条目号")
    @Column(name = "item_no")
    private String itemNo;

    @ApiModelProperty("61850对象参引")
    @Column(name = "paramindex")
    private String paramindex;

    @ApiModelProperty("名称后半部分")
    @Column(name = "part_name")
    private String partName;

}