package com.xydl.cac.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;


@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@ApiModel("查询条件")
public class ConditionModel {

    @ApiModelProperty("id")
    private Integer id;
    @ApiModelProperty("装置ID")
    private Integer devId;
    @ApiModelProperty("页码")
    Integer pageNum;
    @ApiModelProperty("每页数量")
    Integer pageSize;
    @ApiModelProperty("每天最大数量")
    Integer numPerDay;

    @ApiModelProperty("开始时间")
    private Date startTime;
    @ApiModelProperty("结束时间")
    private Date endTime;
    @ApiModelProperty("时间升序")
    boolean timeAsc;
    @ApiModelProperty("不包含开始时间")
    boolean excludeStartTime;

    // 查询告警用
    @ApiModelProperty("处理状态")
    private String state;

    // 导出多个用
    @ApiModelProperty("类型Id")
    private Integer typeId;

}
