package com.xydl.cac.old;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@Api(tags = "旧接口")
@RestController
@RequestMapping("SF6Controller")
public class SF6Controller{

    @Resource
    OldService service;

    /**
     * 查询母线侧隔离开关50511表格数据
     *
     * @param eqmid
     * @return
     */
    @ApiOperation(value = "查询GIS-SF6表格数据")
    @GetMapping(value = "/queryTableData/{eqmid}")
    public AjaxResult queryTableData(@PathVariable Integer eqmid) {
        return AjaxResult.success(service.queryTableDataList3(eqmid));
    }

    /**
     * 查询母线侧隔离开关50511趋势图数据
     *
     * @param eqmid
     * @return
     */
    @ApiOperation(value = "查询GIS-SF6趋势图数据")
    @GetMapping(value = "/queryLineData/{eqmid}")
    public AjaxResult queryLineData(@PathVariable Integer eqmid) {
        return AjaxResult.success(service.queryLineDataList3(eqmid));
    }
}
